## makefs 20091122

=== src/usr.sbin/makefs/Makefile ===
# $MirOS: src/usr.sbin/makefs/Makefile,v 1.20 2009/07/23 19:47:38 tg Exp $
# $NetBSD: Makefile,v 1.22 2008/08/29 00:02:25 gmcgarry Exp $

.include <bsd.own.mk>

PROG=	makefs
SRCS=	buf.c \
	cd9660.c cd9660_strings.c cd9660_debug.c cd9660_eltorito.c \
	cd9660_write.c cd9660_conversion.c iso9660_rrip.c \
	ffs.c ffs_alloc.c ffs_balloc.c ffs_bswap.c ffs_subr.c ffs_tables.c \
	getid.c \
	makefs.c misc.c mkfs.c \
	pack_dev.c \
	spec.c \
	ufs_bmap.c \
	walk.c
MAN=	makefs.8

OStype?=	unknown
.if (${OStype} == "MirBSD") || defined(DEBIAN)
MAKEFS_PORT=	#defined
.endif

.ifdef MAKEFS_PORT
HOSTPROG=	#defined, empty
NETBSDSRCDIR?=	${.CURDIR}/nbsrc
CDIAGFLAGS+=	-Wmissing-declarations -Wmissing-prototypes
CPPFLAGS+=	-DLIBC_SCCS -DHAVE_STRUCT_STAT_BIRTHTIME=0 \
		-DHAVE_NBTOOL_CONFIG_H=0 -DHAVE_NETDB_H=1 \
		-DHAVE_PWCACHE_USERDB=0 -DHAVE_STRSUFTOLL=0
.endif

MKNODSRC=	${NETBSDSRCDIR}/sbin/mknod
MTREESRC=	${NETBSDSRCDIR}/usr.sbin/mtree
UFSSRC=		${NETBSDSRCDIR}/sys/ufs
CD9660SRC=	${NETBSDSRCDIR}/sys/fs/cd9660

CPPFLAGS+=	-I${.CURDIR} \
		-I${MKNODSRC} -I${MTREESRC} -I${CD9660SRC}
.PATH:		${.CURDIR}/ffs ${UFSSRC}/ffs \
		${.CURDIR}/cd9660 ${CD9660SRC} \
		${MKNODSRC} ${MTREESRC}
.ifdef MAKEFS_PORT
CPPFLAGS+=	-I${NETBSDSRCDIR}/sys \
		-I${BSDSRCDIR}/sbin/mknod -I${BSDSRCDIR}/usr.sbin/mtree \
		-I${BSDSRCDIR}/sys -I${BSDSRCDIR}/sys/isofs/cd9660
.PATH:		${BSDSRCDIR}/sys/ufs/ffs ${BSDSRCDIR}/sys/isofs/cd9660 \
		${BSDSRCDIR}/sbin/mknod ${BSDSRCDIR}/usr.sbin/mtree
.endif

.ifdef DEBIAN
LDADD+=		-lbsd
.endif

.if !defined(DEBIAN) && (${HOSTPROG:U} == "")
DPADD+= ${LIBUTIL}
LDADD+= -lutil
.endif

.ifndef MAKEFS_PORT
WARNS?=	3

.if !defined(HOSTPROGNAME)
.if (defined(HAVE_GCC) && ${HAVE_GCC} == 4) || defined(HAVE_PCC)
.for f in cd9660_debug cd9660_write
COPTS.${f}.c+=  -Wno-pointer-sign
.endfor
.endif
.endif

.else	# MirBSD

SRCS+=		pwcache.c
CPPFLAGS+=	-I${NETBSDSRCDIR}/lib/libc/gen
.PATH: ${NETBSDSRCDIR}/lib/libc/gen

SRCS+=		strsuftoll.c
CPPFLAGS+=	-I${NETBSDSRCDIR}/lib/libc/stdlib
.PATH: ${NETBSDSRCDIR}/lib/libc/stdlib

.  ifdef DEBIAN
CPPFLAGS+=	-D_GNU_SOURCE -DDEBIAN
SRCS+=		fparseln.c
.PATH: ${BSDSRCDIR}/lib/libutil
.  else
SRCS+=		stat_flags.c
.PATH: ${NETBSDSRCDIR}/lib/libutil
.  endif
.endif

.include <bsd.prog.mk>

## makefs 20100306

=== src/usr.sbin/makefs/Makefile ===
# $MirOS: src/usr.sbin/makefs/Makefile,v 1.21 2010/03/06 21:29:02 tg Exp $
# $NetBSD: Makefile,v 1.25 2009/04/22 15:23:05 lukem Exp $

WARNS?=	3	# XXX -Wsign-compare

.include <bsd.own.mk>

PROG=	makefs
SRCS=	cd9660.c ffs.c \
	getid.c \
	makefs.c misc.c \
	pack_dev.c \
	spec.c \
	walk.c
MAN=	makefs.8

OStype?=	unknown
.if (${OStype} == "MirBSD") || defined(DEBIAN)
MAKEFS_PORT=	#defined
.endif

.ifdef MAKEFS_PORT
HOSTPROG=	#defined, empty
NETBSDSRCDIR?=	${.CURDIR}/nbsrc
CDIAGFLAGS+=	-Wmissing-declarations -Wmissing-prototypes
CPPFLAGS+=	-DLIBC_SCCS -DHAVE_STRUCT_STAT_BIRTHTIME=0 \
		-DHAVE_NBTOOL_CONFIG_H=0 -DHAVE_NETDB_H=1 \
		-DHAVE_PWCACHE_USERDB=0 -DHAVE_STRSUFTOLL=0
.endif

MKNODSRC=	${NETBSDSRCDIR}/sbin/mknod
MTREESRC=	${NETBSDSRCDIR}/usr.sbin/mtree

CPPFLAGS+=	-I${.CURDIR} -I${MKNODSRC} -I${MTREESRC}
.PATH:		${MKNODSRC} ${MTREESRC}

.include "${.CURDIR}/cd9660/Makefile.inc"
.include "${.CURDIR}/ffs/Makefile.inc"

.ifdef MAKEFS_PORT
CPPFLAGS+=	-I${NETBSDSRCDIR}/sys \
		-I${BSDSRCDIR}/sbin/mknod -I${BSDSRCDIR}/usr.sbin/mtree \
		-I${BSDSRCDIR}/sys -I${BSDSRCDIR}/sys/isofs/cd9660
.PATH:		${BSDSRCDIR}/sys/ufs/ffs ${BSDSRCDIR}/sys/isofs/cd9660 \
		${BSDSRCDIR}/sbin/mknod ${BSDSRCDIR}/usr.sbin/mtree
.endif

.ifdef DEBIAN
LDADD+=		-lbsd
.endif

.if !defined(DEBIAN) && (${HOSTPROG:U} == "")
DPADD+= ${LIBUTIL}
LDADD+= -lutil
.endif

.ifdef MAKEFS_PORT
SRCS+=		pwcache.c
CPPFLAGS+=	-I${NETBSDSRCDIR}/lib/libc/gen
.PATH: ${NETBSDSRCDIR}/lib/libc/gen

SRCS+=		strsuftoll.c
CPPFLAGS+=	-I${NETBSDSRCDIR}/lib/libc/stdlib
.PATH: ${NETBSDSRCDIR}/lib/libc/stdlib

.  ifdef DEBIAN
CPPFLAGS+=	-D_GNU_SOURCE -DDEBIAN
SRCS+=		fparseln.c
.PATH: ${BSDSRCDIR}/lib/libutil
.  else
SRCS+=		stat_flags.c
.PATH: ${NETBSDSRCDIR}/lib/libutil
.  endif
.endif

.include <bsd.prog.mk>

=== debian/changelog ===
makefs (20100306-3) unstable; urgency=low

  * Use debian/source/format 3.0 (quilt) with local single-debian-patch
  * Work with prospective libbsd 0.4.0 (Closes: #670183)
  * Clean up packaging; disable some gcc warnings for now

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 30 Apr 2012 16:52:02 +0000

makefs (20100306-2) unstable; urgency=low

  * makefs can do Multi-Arch: foreign as requested by vorlon
  * Add build-{arch,indep} targets (as alias to build)
  * debian/rules: cleanup (remove install/check, dh_installdirs)
  * Mention lack of Large File Support as a FIXME
  * Policy 3.9.3, no relevant changes
  * debian/rules: modernise; enable +all hardening and --as-needed
  * Use DEB_HOST_ARCH_OS to check whether we’re compiling for Hurd
  * Attempt to use Link-Time Optimisation

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 25 Mar 2012 19:43:59 +0000

makefs (20100306-1) unstable; urgency=low

  * Bump Standards-Version, no relevant change
  * debian/source/format: Enforce "1.0" manually, for now
  * debian/control: Remove DMUA, I'm a DD now
  * New upstream version, with the following change summary:
    - sync with NetBSD® upstream, gives us minor bugfixes and
      support for the Acorn Archimedes (untested)
    - support setting the {creation,modification,effective,expiry}
      date; GNU GRUB 2 uses mtime for “UUID”s…
    - add boot-info-table (J�rg compatible) support
    - get rid of MAXPATHLEN and PATH_MAX; avoid DEV_BSIZE
  * On Hurd, create an empty <sys/mount.h> (Closes: #562297)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 07 Mar 2010 00:42:21 +0000

makefs (20091122-1) unstable; urgency=low

  * New upstream release, summary of changes:
    - Fixes to the bundled manual pages (e.g. - → \-)
  * Add README.Debian containing some notes on this programme

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 15 Dec 2009 11:15:31 +0000

makefs (20090808-2) unstable; urgency=low

  * debian/rules: provide __RCSID if libbsd (< 0.1.3) doesn’t, helps
    backports and avr32; Closes: #547399
  * remove lintian overrides no longer necessary
  * bump Standards-Version 3.8.2 -> 3.8.3, no relevant changes

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 26 Sep 2009 16:57:42 +0000

makefs (20090808-1) unstable; urgency=low

  * Initial release (Closes: #538171)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 08 Aug 2009 13:46:39 +0000

=== debian/control ===
# $MirOS: contrib/hosted/tg/deb/makefs/debian/control,v 1.10 2012/03/25 19:16:07 tg Exp $
#
Source: makefs
Section: otherosfs
Priority: optional
Maintainer: Thorsten Glaser <tg@mirbsd.de>
Homepage: http://cvs.mirbsd.de/src/usr.sbin/makefs/
Build-Depends: debhelper (>= 5), libbsd-dev, pmake
Standards-Version: 3.9.3
# First word is the $CVSROOT (-d arg) string, second word the module.
Vcs-CVS: :ext:_anoncvs@anoncvs.mirbsd.org:/cvs contrib/hosted/tg/deb/makefs
Vcs-Browser: http://cvs.mirbsd.de/contrib/hosted/tg/deb/makefs/

Package: makefs
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: create a cd9660 or ffs file system image from a directory tree
 NetBSD® makefs(8) creates a file system image from a directory tree
 without the need for superuser privileges. The MirBSD version fixes
 ECMA 119, SUSP and RRIP (Rock Ridge) compliance and adds features.
 .
 Supported target filesystem types are:
 .
    cd9660   ISO 9660 (ECMA 119) compatible filesystem images, with
             Rock Ridge, El Torito, and other features
    ffs      4.2FFS, the BSD Fast Filesystem, also known as UFS1;
             UFS2 (with "-o version=2")
 .
 The images created can be of a fixed (predefined) size, given on the
 command line, or sized automatically. Permission bits are taken from
 the source directory tree but may be overridden using an mtree file.
 .
 This utility does not currently support Large Files (2 GiB or more).

=== debian/rules ===
#!/usr/bin/make -f
# $MirOS: contrib/hosted/tg/deb/makefs/debian/rules,v 1.14 2012/04/30 16:48:39 tg Exp $

shellescape='$(subst ','\'',$(1))'
shellexport=$(1)=$(call shellescape,${$(1)})

DEB_HOST_ARCH_OS?=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

CC?=			gcc
EXTRA_CFLAGS+=		-Wall -Wformat
EXTRA_CPPFLAGS+=	-include /usr/include/bsd/bsd.h
EXTRA_CPPFLAGS+=	-idirafter /usr/include/bsd
EXTRA_LDFLAGS=		-Wl,--as-needed

# not yet (needs to be checked upstream)
EXTRA_CFLAGS+=		-Wno-unused-but-set-variable
EXTRA_CFLAGS+=		-Wno-unused-result

ifneq (,$(wildcard /usr/share/dpkg/buildflags.mk))
# dpkg-dev (>= 1.16.1~)
DEB_CFLAGS_MAINT_APPEND=${EXTRA_CFLAGS}
DEB_CPPFLAGS_MAINT_APPEND=${EXTRA_CPPFLAGS}
DEB_LDFLAGS_MAINT_APPEND=${EXTRA_LDFLAGS}
DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk
else
# old-fashioned way to determine build flags
CFLAGS=			-O$(if $(findstring noopt,${DEB_BUILD_OPTIONS}),0,2) -g
CFLAGS+=		${EXTRA_CFLAGS}
CPPFLAGS+=		${EXTRA_CPPFLAGS}
LDFLAGS+=		${EXTRA_LDFLAGS}
endif

# should be in libbsd
DEFS+=	-D'__IDSTRING(x,y)=static const char x[] __attribute__((used)) = y'
DEFS+=	-D'__KERNEL_RCSID(x,y)=__IDSTRING(kernelrcsid_ \#\# x,y)'
DEFS+=	-D'__dead=__attribute__((noreturn))'
DEFS+=	-D'_DIAGASSERT(x)='

# is in libbsd, but not all versions: Debian #547399
ifeq ($(shell fgrep -ch __RCSID \
    /usr/include/bsd/cdefs.h /usr/include/bsd/sys/cdefs.h \
    2>/dev/null),0)
DEFS+=	-D'__RCSID(x)=__IDSTRING(rcsid,x)'
endif

DEFS+=	-D'bswap16=__bswap_16'
DEFS+=	-D'bswap32=__bswap_32'
DEFS+=	-D'bswap64=__bswap_64'
DEFS+=	-DHAVE_STRUCT_STATVFS_F_IOSIZE=0
DEFS+=	-DHAVE_STRUCT_STAT_ST_MTIMENSEC=0
DEFS+=	-DHAVE_STRUCT_STAT_ST_FLAGS=0
DEFS+=	-DHAVE_STRUCT_STAT_ST_GEN=0

PMAKE_FLAGS:=	BSDSRCDIR="$$_topdir/builddir"
PMAKE_FLAGS+=	DEBIAN=Yes
# disable -Werror for package build (comment this out if developing)
PMAKE_FLAGS+=	NOGCCERROR=Yes

build build-arch: builddir/.build_stamp
build-indep:

builddir/.build_stamp:
	dh_testdir
	-rm -rf builddir
	mkdir builddir
	cp -r src/* builddir/
ifeq (${DEB_HOST_ARCH_OS},hurd)
	mkdir -p builddir/usr.sbin/makefs/sys
	:>builddir/usr.sbin/makefs/sys/mount.h
endif
	# pmake in Debian is pretty buggy
	+_topdir=$$(pwd); cd builddir/usr.sbin/makefs; \
	 for opts in '-flto=jobserver' ''; do \
		set -x; \
		$(foreach i,CC CFLAGS LDFLAGS,$(call shellexport,$i)); \
		CPPFLAGS=$(call shellescape,${CPPFLAGS} ${DEFS}); \
		CFLAGS="$$CFLAGS $$opts"; \
		LDFLAGS="$$CFLAGS $$LDFLAGS"; \
		export LC_ALL=C CC CFLAGS CPPFLAGS LDFLAGS; \
		pmake ${PMAKE_FLAGS} makefs || continue; \
		test -x makefs && exit 0; \
	done; echo >&2 Compiling failed.; exit 1
	@:>$@

clean:
	dh_testdir
	-rm -rf builddir
	dh_clean

binary-indep:

binary-arch: build-arch
	dh_testdir
	dh_testroot
	if test -x "$$(which dh_prep)"; then dh_prep; else dh_clean -k; fi
	dh_installchangelogs
	dh_installdocs
	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: binary binary-arch binary-indep build build-arch build-indep clean

=== debian/watch ===
# $MirOS: contrib/hosted/tg/deb/makefs/debian/watch,v 1.1 2009/08/08 13:24:00 tg Exp $

version=3
http://www.mirbsd.org/MirOS/dist/mir/makefs/ makefs-(.*)\.tar\.gz

## makefs 20190105

=== src/usr.sbin/makefs/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $MirOS: src/usr.sbin/makefs/Makefile,v 1.21 2010/03/06 21:29:02 tg Exp $
+# $MirOS: src/usr.sbin/makefs/Makefile,v 1.28 2019/01/05 16:39:26 tg Exp $
 # $NetBSD: Makefile,v 1.25 2009/04/22 15:23:05 lukem Exp $
 
 WARNS?=	3	# XXX -Wsign-compare
@@ -15,7 +15,7 @@
 MAN=	makefs.8
 
 OStype?=	unknown
-.if (${OStype} == "MirBSD") || defined(DEBIAN)
+.if (${OStype} == "MirBSD") || defined(GNUPORT)
 MAKEFS_PORT=	#defined
 .endif
 
@@ -34,8 +34,8 @@
 CPPFLAGS+=	-I${.CURDIR} -I${MKNODSRC} -I${MTREESRC}
 .PATH:		${MKNODSRC} ${MTREESRC}
 
-.include "${.CURDIR}/cd9660/Makefile.inc"
-.include "${.CURDIR}/ffs/Makefile.inc"
+.include "cd9660/Makefile.inc"
+.include "ffs/Makefile.inc"
 
 .ifdef MAKEFS_PORT
 CPPFLAGS+=	-I${NETBSDSRCDIR}/sys \
@@ -45,11 +45,7 @@
 		${BSDSRCDIR}/sbin/mknod ${BSDSRCDIR}/usr.sbin/mtree
 .endif
 
-.ifdef DEBIAN
-LDADD+=		-lbsd
-.endif
-
-.if !defined(DEBIAN) && (${HOSTPROG:U} == "")
+.if !defined(GNUPORT) && (${HOSTPROG:U} == "")
 DPADD+= ${LIBUTIL}
 LDADD+= -lutil
 .endif
@@ -63,13 +59,26 @@
 CPPFLAGS+=	-I${NETBSDSRCDIR}/lib/libc/stdlib
 .PATH: ${NETBSDSRCDIR}/lib/libc/stdlib
 
-.  ifdef DEBIAN
-CPPFLAGS+=	-D_GNU_SOURCE -DDEBIAN
+.  ifndef GNUPORT
+SRCS+=		stat_flags.c
+.PATH: ${NETBSDSRCDIR}/lib/libutil
+
+.  else
+CPPFLAGS+=	-D_GNU_SOURCE -DGNUPORT
 SRCS+=		fparseln.c
 .PATH: ${BSDSRCDIR}/lib/libutil
-.  else
-SRCS+=		stat_flags.c
-.PATH: ${NETBSDSRCDIR}/lib/libutil
+
+CPPFLAGS+=	-I${BSDSRCDIR}/include
+SRCS+=		setmode.c unvis.c
+.PATH: ${BSDSRCDIR}/lib/libc/gen
+
+SRCS+=		fgetln.c
+.PATH: ${BSDSRCDIR}/../contrib/code/mirmake/dist/contrib
+
+SRCS+=		strlfun.c
+CPPFLAGS+=	-DOUTSIDE_OF_LIBKERN -DNEED_STRLFUN_PROTOS
+CPPFLAGS+=	-DL_strlcpy -DL_strlcat
+.PATH: ${BSDSRCDIR}/kern/c
 .  endif
 .endif

=== src/usr.sbin/mtree/Makefile ===
# $MirOS: src/usr.sbin/mtree/Makefile,v 1.3 2005/04/13 20:30:16 tg Exp $
# $OpenBSD: Makefile,v 1.7 2004/05/02 17:55:53 millert Exp $

PROG=	mtree
#CPPFLAGS+=-DDEBUG
MAN=	mtree.8
SRCS=	compare.c crc.c create.c misc.c mtree.c spec.c verify.c

CPPFLAGS+=	$(INCS)
LDADD+=		$(LIBS)

.include <bsd.prog.mk>

=== debian/changelog ===
makefs (20190105-3) unstable; urgency=high

  * Team upload.
  * Require and build with recent bmake which broke its r-builddeps
    (without even so much as a notice in advance)
  * Do not pass -Wl,--as-needed (manually) any more, thanks lintian
  * Use debhelper 13
  * Update lintian overrides; add UMEGAYA metadata

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 26 Jul 2020 18:34:09 +0200

makefs (20190105-2) unstable; urgency=medium

  * Team upload.
  * Update Uploaders (name)
  * Bump Policy (no relevant changes)
  * Do not build with LTO (buggy/unreliable in GCC)
  * Slightly modernise and correct packaging
  * Define __packed, missing in glibc headers (Closes: #957516)

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 17 Apr 2020 23:45:54 +0200

makefs (20190105-1) unstable; urgency=low

  * Team upload.
  * Update to latest version from MirBSD, merges all Debian patches
    - Remove libbsd dependency, now unusable
  * Bump debhelper to 12, Policy 4.3.0 (no changes)

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 05 Jan 2019 17:53:32 +0100

makefs (20100306-7) unstable; urgency=medium

  * Convert to standard patches-unapplied format
  * Fix FTBFS with glibc 2.28 (Closes: #916004)
  * Switch from transitional pmake to bmake
  * Bump debhelper compat level to 11
  * debian/rules: Use dh sequencer and modernise
  * debian/control:
    - Update Vcs-* to point to salsa
    - Bump Standards-Version to 4.2.1; no changes needed
    - Add Rules-Requires-Root: no
    - Run wrap-and-sort -ast
    - Add myself to Uploaders

 -- James Clarke <jrtc27@debian.org>  Sun, 09 Dec 2018 21:27:46 +0000

makefs (20100306-6) unstable; urgency=medium

  * New maintainer: GNU/kFreeBSD Maintainers. (Closes: #764399)
  * Add myself to Uploaders.
  * Bump Standards-Version to 3.9.6;  no change needed.
  * Implement -T maximum-time argument, to clamp superblock and
    file timestamps to a given Epoch time, for reproducibility.

 -- Steven Chamberlain <steven@pyro.eu.org>  Wed, 11 Nov 2015 11:56:26 +0000

makefs (20100306-5) unstable; urgency=low

  * QA upload.
  * Orphan the package.

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 07 Oct 2014 18:02:14 +0000

makefs (20100306-4) unstable; urgency=low

  * Use __…__ around GCC __attribute__s
  * debian/control: Move VCS-* fields to Alioth collab-maint git
  * Remove now-useless RCS IDs
  * Bump Policy version
  * Update debian/copyright file

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 08 Jul 2014 16:25:28 +0200

=== debian/control ===
Source: makefs
Section: otherosfs
Priority: optional
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Uploaders:
 Steven Chamberlain <steven@pyro.eu.org>,
 Jessica Clarke <jrtc27@debian.org>
Homepage: http://cvs.mirbsd.de/src/usr.sbin/makefs/
Build-Depends:
 bmake (>= 20200710-1~),
 debhelper-compat (= 13),
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/bsd-team/makefs.git
Vcs-Browser: https://salsa.debian.org/bsd-team/makefs

Package: makefs
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: create a cd9660 or ffs filesystem image from a directory tree
 NetBSD® makefs(8) creates a filesystem image from a directory tree
 without the need for superuser privileges. The MirBSD version fixes
 ECMA 119, SUSP and RRIP (Rock Ridge) compliance and adds features.
 .
 Supported target filesystem types are:
 .
    cd9660   ISO 9660 (ECMA 119) compatible filesystem images, with
             Rock Ridge, El Torito, and other features
    ffs      4.2FFS, the BSD Fast Filesystem, also known as UFS1;
             UFS2 (with "-o version=2")
 .
 The images created can be of a fixed (predefined) size, given on the
 command line, or sized automatically. Permission bits are taken from
 the source directory tree but may be overridden using an mtree file.
 .
 This utility does not currently support Large Files (2 GiB or more).

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C
export LC_ALL

shellescape='$(subst ','\'',$(1))'
shellexport=$(1)=$(call shellescape,${$(1)})

DEB_HOST_ARCH_OS?=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

DEB_CFLAGS_MAINT_APPEND+=	-Wall -Wformat

# not yet (needs to be checked upstream)
DEB_CFLAGS_MAINT_APPEND+=	-Wno-unused-but-set-variable
DEB_CFLAGS_MAINT_APPEND+=	-Wno-unused-result

DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk

DEFS+=	-D'__IDSTRING(x,y)=static const char x[] __attribute__((__used__)) = y'
DEFS+=	-D'__RCSID(x)=__IDSTRING(rcsid,x)'
DEFS+=	-D'__SCCSID(x)=__IDSTRING(sccsid,x)'
DEFS+=	-D'__KERNEL_RCSID(x,y)=__IDSTRING(kernelrcsid_ \#\# x,y)'
DEFS+=	-D'__dead=__attribute__((__noreturn__))'
DEFS+=	-D'__packed=__attribute__((__packed__))'
DEFS+=	-D'_DIAGASSERT(x)='

DEFS+=	-D'bswap16=__bswap_16'
DEFS+=	-D'bswap32=__bswap_32'
DEFS+=	-D'bswap64=__bswap_64'
DEFS+=	-DHAVE_STRUCT_STATVFS_F_IOSIZE=0
DEFS+=	-DHAVE_STRUCT_STAT_ST_MTIMENSEC=0
DEFS+=	-DHAVE_STRUCT_STAT_ST_FLAGS=0
DEFS+=	-DHAVE_STRUCT_STAT_ST_GEN=0
DEFS+=	-DS_ISTXT=S_ISVTX

BMAKE_FLAGS:=	BSDSRCDIR="$$_topdir/builddir"
BMAKE_FLAGS+=	GNUPORT=Yes
# disable -Werror for package build (comment this out if developing)
BMAKE_FLAGS+=	NOGCCERROR=Yes

%:
	dh $@ --builddirectory=builddir

override_dh_auto_build-arch:
	dh_testdir
	-rm -rf builddir
	mkdir builddir
	cp -r src/* builddir/
ifeq (${DEB_HOST_ARCH_OS},hurd)
	mkdir -p builddir/usr.sbin/makefs/sys
	:>builddir/usr.sbin/makefs/sys/mount.h
endif
	# bmake in Debian is pretty buggy
	_topdir=$$(pwd); cd builddir/usr.sbin/makefs; \
	    $(foreach i,CC CFLAGS LDFLAGS,$(call shellexport,$i)); \
	    CPPFLAGS=$(call shellescape,${CPPFLAGS} ${DEFS}); \
	    LDFLAGS="$$CFLAGS $$LDFLAGS"; \
	    export CC CFLAGS CPPFLAGS LDFLAGS; \
	    bmake -m /usr/share/bmake/mk-netbsd ${BMAKE_FLAGS} makefs
	test -x builddir/usr.sbin/makefs/makefs

override_dh_auto_clean:
	dh_testdir
	-rm -rf builddir

=== debian/watch ===
version=3
http://www.mirbsd.org/MirOS/dist/mir/makefs/ makefs-(.*)\.tar\.gz
